public class CappedZCylinder extends Object3
{
  public ZCylinder cyl;
  public double zmin, zmax;
  
  public CappedZCylinder(ZCylinder c, double mn, double mx)
  {
    super(c.material);
    cyl = c;
    zmin = mn;
    zmax = mx;
  }

  public double intersect(Ray r)
  {
    double t = cyl.intersect(r);
    if (t == Double.NaN) {
      return t;
    }

    double z = r.origin.z + r.direction.z * t;
    if (z > zmin && z < zmax) return t;
    return Double.NaN;
  }

  public Vector3 normal(Vector3 p)
  {
    return cyl.normal(p);
  }
}
