import java.awt.*;

public class FloatColor
{
  public double red, green, blue;
  public double EXPOSURE = -1.0;
  public double GAMMA = 2.2;

  public static final FloatColor WHITE = new FloatColor(1.0, 1.0, 1.0);
  public static final FloatColor BLACK = new FloatColor(0.0, 0.0, 0.0);
  public static final FloatColor RED = new FloatColor(1.0, 0.0, 0.0);
  public static final FloatColor GREEN = new FloatColor(0.0, 1.0, 0.0);
  public static final FloatColor BLUE = new FloatColor(0.0, 0.0, 1.0);

  public FloatColor(double r, double g, double b)
  {
    red = r;
    green = g;
    blue = b;
  }

  public FloatColor add(FloatColor c)
  {
    return new FloatColor(red + c.red, green + c.green, blue + c.blue);
  }

  public FloatColor mult(FloatColor c)
  {
    return new FloatColor(red * c.red, green * c.green, blue * c.blue);
  }

  public FloatColor mult(double d)
  {
    return new FloatColor(red * d, green * d, blue * d);
  }

  public FloatColor pow(double d)
  {
    return new FloatColor(Math.pow(red, d), Math.pow(green, d), Math.pow(blue, d));
  }

  public Color toColor()
  {
    //converts to Color. Implements saturation and gamma correction.
    int iRed = (int) (255 * Math.pow(1.0 - Math.exp(red * EXPOSURE), 1 / GAMMA));
    int iGreen = (int) (255 * Math.pow(1.0 - Math.exp(green * EXPOSURE), 1 / GAMMA));
    int iBlue = (int) (255 * Math.pow(1.0 - Math.exp(blue * EXPOSURE), 1 / GAMMA));
    
    return new Color(iRed, iGreen, iBlue);
  }
  
  public String toString()
  {
    return red + " " + green + " " + blue;
  }
}
