public class Material
{
  public FloatColor emittance;
  public FloatColor reflectance;
  public double ior, transparency;
  public VectorFunction func;

  public Material(FloatColor e, FloatColor r)
  {
    emittance = e;
    reflectance = r;
    ior = 1;
    transparency = 0;
    func = new DiffuseFunction();
  } 

  public Material(FloatColor e, FloatColor r, VectorFunction f)
  {
    emittance = e;
    reflectance = r;
    ior = 1;
    transparency = 0;
    func = f;
  } 

  public Material(FloatColor e, FloatColor r, VectorFunction f, double n, double t)
  {
    emittance = e;
    reflectance = r;
    ior = n;
    transparency = t;
    func = f;
  } 

  public Vector3 reflect(Vector3 incident, Vector3 normal)
  {
    return func.f(incident, normal);
  }
}
