public abstract class Object3
{
  /**
   * A small double value, used to avoid rounding error during intersections
  */
  public static final double TOLERANCE = 0.0001;
  public Material material;

  /**
   * Creates a new Object3 with Material m
  */
  public Object3(Material m)
  {
    material = m;
  }

  /**
    * Returns the t-value of the nearest positive intersection between r and this Object3,
    * or Double.NaN if no such intersection
  */
  public abstract double intersect(Ray r);


  /**
   * Returns the normal to this Object3 at point v
  */
  public abstract Vector3 normal(Vector3 v);
}
