public class Ray
{
  public Vector3 origin;
  public Vector3 direction;
  

  public Ray(Vector3 o, Vector3 d)
  {
    origin = o;
    direction = d.normalize();
  }

  public Vector3 valueAt(double t)
  {
    if (t == Double.NaN) {
      return null;
    }

    return new Vector3(origin.x + t * direction.x,
                      origin.y + t * direction.y,
                      origin.z + t * direction.z); 
  }

  public String toString()
  {
    return origin + " + t * " + direction;
  }
}
