public class Refract
{
  public static Vector3 refract(Vector3 V, Vector3 N, double n1, double n2)
  {
    double n = n1 / n2;
    double c1 = -N.dot(V);
    double c2 = Math.sqrt(1 - n * n * (1 - c1 * c1));
    if (c2 == Double.NaN) {
      return null;
    }
    if (c1 > 0) {
      return V.mult(n).add(N.mult(n * c1 - c2));
    }
    return V.mult(n).add(N.mult(n * c1 + c2));
  }
}
