public class Sphere extends Object3
{
  private Vector3 center;
  private double radius;

  public Sphere(Vector3 c, double r, Material m)
  {
    super(m);
    center = c;
    radius = r;
  }

  public Vector3 normal(Vector3 v)
  {
    return v.sub(center).normalize();
  }

  public double intersect(Ray r)
  {
    Vector3 vtemp = r.origin.sub(center);
    double b = r.direction.dot(vtemp.mult(2));
    double c = vtemp.dot(vtemp) - radius * radius;  
    double disc = b * b - 4 * c;
    if (disc < 0) {
      return Double.NaN;
    }
    double t0 = (-b - disc) / 2;
    if (t0 > TOLERANCE) {
      return t0;
    } 
    double t1 = (-b + disc) / 2;
    if (t1 > TOLERANCE) {
      return t1;
    }
    return Double.NaN;
  }
}
