public class Vector3
{
  public double x, y, z;

  public Vector3(double a, double b, double c)
  {
    x = a;
    y = b;
    z = c;
  }

  public Vector3 add(Vector3 v)
  {
    return new Vector3(x + v.x, y + v.y, z + v.z);
  }

  public Vector3 negate()
  {
    return new Vector3(-x, -y, -z);
  }

  public Vector3 sub(Vector3 v)
  {
    return this.add(v.negate());
  }

  public double length()
  {
    return Math.sqrt(x * x + y * y + z * z);
  }

  public Vector3 mult(double d)
  {
    return new Vector3(x * d, y * d, z * d);
  }

  public Vector3 div(double d)
  {
    return this.mult(1.0 / d);
  }

  public Vector3 normalize()
  {
    return this.div(this.length());
  }

  public double dot(Vector3 v)
  {
    return x * v.x + y * v.y + z * v.z;
  }

  public Vector3 cross(Vector3 v)
  {
    return new Vector3(y * v.z - z * v.y, v.z * x - x * v.z, x * v.y - y * v.x); 
  }

  public String toString()
  {
    return "<" + x + ", " + y + ", " + z + ">";
  }
}
