public class XYPlane extends Object3
{
  public double z;
  public double normal;

  public XYPlane(Material m, double d, double n)
  {
    super(m);
    z = d;
    normal = n / Math.abs(n);
  }

  public double intersect(Ray r)
  {
    double dirZ = r.direction.z;
    double startZ = r.origin.z;

    if (dirZ == 0) {
      return Double.NaN;
    }

    double t = (z - startZ) / dirZ;

    if (t < TOLERANCE) {
      return Double.NaN;
    } else {
      return t;
    }
  }

  public Vector3 normal(Vector3 p)
  {
    return new Vector3(0, 0, normal);
  }
}
