public class XYRectangle extends XYPlane
{
  public double xmin, xmax, ymin, ymax;

  public XYRectangle(Material m, double d, double n, double xmn, double xmx, double ymn, double ymx)
  {
    super(m, d, n);
    xmin = xmn;
    xmax = xmx;
    ymin = ymn;
    ymax = ymx;
  }

  public double intersect(Ray r)
  {
    double d = super.intersect(r);

    if (d == Double.NaN) {
      return d;
    }

    Vector3 v = r.valueAt(d);

    if (xmin <= v.x && v.x <= xmax && ymin <= v.y && v.y <= ymax) {
      return d;
    }

    return Double.NaN;
  }
}
