public class XZPlane extends Object3
{
  public double y;
  public double normal;

  public XZPlane(Material m, double yy, double n)
  {
    super(m);
    y = yy;
    normal = n / Math.abs(n);
  }

  public double intersect(Ray r)
  {
    if (r.direction.y == 0) {
      return Double.NaN;
    }

    double t = (y - r.origin.y) / r.direction.y;
    if (t > TOLERANCE) {
      return t;
    }

    return Double.NaN;
  }

  public Vector3 normal(Vector3 p)
  {
    return new Vector3(0, normal, 0);
  }
}
