public class YZPlane extends Object3
{
  public double x;
  public double normalDir;


  public YZPlane(Material m, double d, double n)
  {
    super(m);
    x = d;
    normalDir = n / Math.abs(n);
  }

 public double intersect(Ray r)
 {
   double  dirX = r.direction.x;
   double startX = r.origin.x;
   
   if (dirX == 0) {
     return Double.NaN;
   }

   double t = (x - startX) / dirX;
   
   if (t < TOLERANCE) {
     return Double.NaN;
   } else {
     return t;
   }
 } 

 public Vector3 normal(Vector3 p)
 {
   return new Vector3(normalDir, 0, 0);
 }
   
}
